import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
        return TAG_RE.sub('', text)

class NoticiasItem(scrapy.Item):
        title = scrapy.Field()
        text = scrapy.Field()
        date = scrapy.Field()
        location = scrapy.Field()
        author = scrapy.Field()
        topic = scrapy.Field()
        url = scrapy.Field()

class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		year = getattr(self, 'year', None)
		month = getattr(self, 'month', None)
		day = getattr(self, 'day', None)
		self.baseURL='http://alchile.com.mx/'+year+'/'+month+'/'+day
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)

	def parse(self, response):
		pages = response.css('div.page-nav').css('a.last::attr(href)').extract_first().strip('/')
		pages =  int(pages[pages.rfind('/')+1:])
		for p in range(0,pages):
			if ( p == 0 ):
				yield scrapy.Request(url=response.url+"/page/"+str(p+1), callback=self.parse_page, dont_filter=True)
			else:
				yield scrapy.Request(url=response.url+"/page/"+str(p+1), callback=self.parse_page)

	def parse_page(self, response):
		for link in response.css('div.td-block-span6').css('h3.entry-title').css('a::attr(href)').extract():
			yield scrapy.Request(url=link, callback=self.parse_item)

	def parse_item(self, response):
		item = NoticiasItem()
		item['title'] = response.css('header.td-post-title').css('h1.entry-title::text').extract_first()
		item['date'] = response.css('span.td-post-date').css('time.entry-date::attr(datetime)').extract_first()
		item['topic'] = response.css('div.td-post-header').css('a::text').extract_first()
		item['text'] = response.css('div.td-post-content').css('p::text').extract()
		item['url'] = response.url
		print item['title']
		yield item

