import scrapy

#scrapy crawl noticias -t json --nolog -o noticias.json -a year=2017 -a month=3 -a day=22

import re

TAG_RE = re.compile(r'<[^>]+>')
def remove_tags(text):
	return TAG_RE.sub('', text)

class NoticiasItem(scrapy.Item):
        title = scrapy.Field()
        text = scrapy.Field()
        date = scrapy.Field()
        location = scrapy.Field()
        author = scrapy.Field()
        topic = scrapy.Field()
        url = scrapy.Field()

class QuotesSpider(scrapy.Spider):
	name = "noticias"
	def start_requests(self):
		year = getattr(self, 'year', None)
		month = getattr(self, 'month', None)
		day = getattr(self, 'day', None)
		self.baseURL='http://laverdadnoticias.com/'+year+'/'+month+'/'+day
		urls = [
			self.baseURL,
                ]
		for url in urls:
			yield scrapy.Request(url=url, callback=self.parse)

	def parse(self, response):
		pages = response.css("div.pagination_div").css("a::attr(href)")[-2].extract().strip('/')
		pages =  int(pages[pages.rfind('/')+1:])
		for p in range(0,pages):
			if ( p == 0 ):
				yield scrapy.Request(url=response.url+"/page/"+str(p+1), callback=self.parse_page, dont_filter=True)
			else:
				yield scrapy.Request(url=response.url+"/page/"+str(p+1), callback=self.parse_page)

	def parse_page(self, response):
		linkList = response.css("div.cp-post-content").css("h3").css("a::attr(href)").extract()
		for link in range(0,len(linkList)-3):
			yield scrapy.Request(url=linkList[link], callback=self.parse_item)

	def parse_item(self, response):
		item = NoticiasItem()
		item['title'] = response.css("div.cp-post-content").css("h1").css("a::text").extract_first()
		print item['title']
		item['date'] = response.xpath("//meta[@property=$val]/@content", val="article:published_time").extract()
		item['text'] = remove_tags( response.css("div.cp-post-content").css("p").extract_first() )
		item['url'] = response.url
		yield item